#!/bin/sh

CVSROOT=~/cvsroot
RPMROOT=~/rpm
ROOT=~/firestorm-build
DIR="firestorm-0.5.1"
TAG="HEAD"

## export from CVS and cd into root
mkdir -p $ROOT
cvs -d $CVSROOT export -r $TAG -d $ROOT/$DIR firestorm
pushd $ROOT/$DIR


## Setup the source code
aclocal
autoheader
automake -c -a --gnu
libtoolize --automake -c -f
autoconf


## Make the source tarball
cd ..
tar -zcf $DIR.tar.gz $DIR


## Prepare to make the RPMs
cp $DIR/firestorm.spec $RPMROOT/SPECS/
cp $DIR.tar.gz $RPMROOT/SOURCES/
pushd $RPMROOT

# Build the PPC RPMs
rpmbuild -ba SPECS/firestorm.spec
rpmbuild --clean SPECS/firestorm.spec

# Build the intel RPMs
env CC=i486-redhat-linux-gcc rpmbuild -ba --target=i386-redhat-linux SPECS/firestorm.spec
rpmbuild --clean SPECS/firestorm.spec

rm -f SPECS/firestorm.spec
rm -f SOURCES/$DIR.tar.gz

mv RPMS/*/firestorm-*.rpm $ROOT
mv SRPMS/firestorm-*.rpm $ROOT

popd


## Finish up
rm -rf $ROOT/$DIR
popd
