#ifndef __MATCHER_HEADER_INCLUDED__
#define __MATCHER_HEADER_INCLUDED__

/* Cleanup said data structure */
typedef void(*proc_match_cleanup)(void *);

/* Compare two private data structures */
typedef int(*proc_match_compare)(void *, void *);

/* match a packet against private data */
#define proc_match_match_t
typedef int(*proc_match_match)(struct packet *, void *, unsigned int, int);

/* Takes a parsed token and creates a private data structure */
typedef proc_match_match(*proc_match_validate)(char *, void **, struct criteria *, u_int32_t *cost);

/* The matcher structure */
struct matcher {
	struct matcher		*next;
	char			*name;
	proc_match_compare	compare;
	proc_match_validate	validate;
	proc_match_cleanup	cleanup;
	u_int32_t		cost;
};

#define MCOST_LINK	1000
#define MCOST_NET	2000
#define MCOST_TRANS	3000
#define MCOST_APP	4000
#define MCOST_DATA	5000

#ifndef __PLUGIN__
struct matcher *matcher_find(char *);
int matcher_add(char *, u_int32_t,
	proc_match_validate,
	proc_match_compare,
	proc_match_cleanup);
#else
typedef struct matcher *(*proc_matcher_find)(char *);
typedef int (*proc_matcher_add)(char *, u_int32_t,
	proc_match_validate,
	proc_match_compare,
	proc_match_cleanup);
#endif

#endif /* __MATCHER_HEADER_INCLUDED__ */
