#include "match_tcp.h"
PLUGIN_STD_DEFS();

int _PLUGIN_INIT (struct plugin_in *in, struct plugin_out *out)
{
	int ok=0;
	proc_matcher_add matcher_add;
	
	plugin_check(in, out);
	
	PLUGIN_ID("match.tcp", "TCP matching routines");
	PLUGIN_VERSION(2, 0);
	PLUGIN_AUTHOR("Gianni Tedesco", "gianni@scaramanga.co.uk");
	PLUGIN_LICENSE("GPL");

	if ( !(matcher_add=in->import("matcher.add")) ) {
		return PLUGIN_ERR_OBJECT;
	}
	
	if ( !(template_longrange=in->import("template.longrange")) ) {
		return PLUGIN_ERR_OBJECT;
	}

	if ( !(template_shortrange=in->import("template.shortrange")) ) {
		return PLUGIN_ERR_OBJECT;
	}

	ok+=matcher_add("tcp_sport", 13,
		tcp_src_validate,
		in->import("template.cmp_sr"),
		in->import("template.ptr"));

	ok+=matcher_add("tcp_dport", 14,
		tcp_dst_validate,
		in->import("template.cmp_sr"),
		in->import("template.ptr"));
	
	ok+=matcher_add("flags", MCOST_TRANS+13,
		flags_validate,
		flags_compare,
		in->import("template.ptr"));

	ok+=matcher_add("seq", MCOST_TRANS+4,
		seq_validate,
		in->import("template.cmp_lr"),
		in->import("template.ptr"));
	
	ok+=matcher_add("ack", MCOST_TRANS+6,
		ack_validate,
		in->import("template.cmp_lr"),
		in->import("template.ptr"));

	ok+=matcher_add("flow", 9,
		flow_validate,
		in->import("template.cmp_lr"),
		in->import("template.ptr"));

	ok+=matcher_add("stateless", 9,
		stateless_validate,
		in->import("template.cmp_lr"),
		in->import("template.ptr"));


	return (ok) ? PLUGIN_ERR_OK : PLUGIN_ERR_FAIL;
	return (ok) ? PLUGIN_ERR_OK : PLUGIN_ERR_FAIL;
}

int _PLUGIN_UNLOAD (int code) {
	return PLUGIN_ERR_OK;
}
